#!/usr/bin/perl -w
use strict;
#use Math::CDF qw(:all);


my $Unanimous=0;
my $QuasiUnanimous=0;
my $Discarded=0;
my $DiscardedBis=0;
my $ToMetaAnnotate=0;
my $MetaAnnotated=0;
my $numDiscardedInMetaAnnotation=0;
my $numTweets=0;
my $numUndecidableTweets=0;
my $numRelatedTweets=0;
my $numNonRelatedTweets=0;
my %annot=();
my $numAnnotatedTweets=0;
my $numTweetsWithEmptyAnnotation=0;

my %tweetEntity=();
my %entityNames=();
my @systems=split(/\s/,$ARGV[1]);
my $numFallosLectura=0;
open (FICH,$ARGV[0]) or die; 
my $line1=<FICH>;
while (my $line=<FICH>){
  chop $line;
  (my $entity_name, my $query, my $tweet_id, my $tweet_author, my $tweet_content, my  $annot_1, my $turker_1, my $annot_2, my $turker_2, my $annot_3, my $turker_3, my $annot_4, my $turker_4, my $annot_5, my $turker_5, my $meta_annotation)=split(/\t/,$line);


my $numEntries=split(/\t/,$line);
  if (!($numEntries==16)){
    # print "ATENCIN  $numEntries $tweet_id\n";
    $numFallosLectura++;
  }else{
    
    if (($annot_1 eq "empty")||($annot_2 eq "empty")||($annot_3 eq "empty")||($annot_4 eq "empty")||($annot_5 eq "empty")){
      
      $numTweetsWithEmptyAnnotation++;
    }else{
    $numTweets++;    
    $entity_name=lc($entity_name);
    $entity_name=~ s/^\s+//;
    $entity_name=~ s/\s+$//;
    $tweetEntity{$tweet_id}=$entity_name;
    $entityNames{$entity_name}=1;
    my $cRelated=0;
    if ($annot_1 eq "related"){
      $cRelated++;
    }  
    if ($annot_2 eq "related"){
      $cRelated++;
    }    
    if ($annot_3 eq "related"){
      $cRelated++;
    }
    if ($annot_4 eq "related"){
      $cRelated++;
    }    
    if ($annot_5 eq "related"){
      $cRelated++;
    }  
    
    my $cNon_related=0;
    if ($annot_1 eq "non_related"){
    $cNon_related++;
  }  
    if ($annot_2 eq "non_related"){
      $cNon_related++;
    }    
    if ($annot_3 eq "non_related"){
      $cNon_related++;
    }
    if ($annot_4 eq "non_related"){
      $cNon_related++;
    }    
    if ($annot_5 eq "non_related"){
      $cNon_related++;
    }  
    
    my $cUndecidable=0;
    if ($annot_1 eq "undecidable"){
      $cUndecidable++;
    }  
    if ($annot_2 eq "undecidable"){
      $cUndecidable++;
    }    
    if ($annot_3 eq "undecidable"){
      $cUndecidable++;
    }
    if ($annot_4 eq "undecidable"){
      $cUndecidable++;
    }    
    if ($annot_5 eq "undecidable"){
      $cUndecidable++;
    }  
    
    my $check=0;

    if (($cRelated==5)||(($cRelated==4)&&($cUndecidable==0))){
      $Unanimous++;
      $annot{$tweet_id}="related";
      $numRelatedTweets++;
      $numAnnotatedTweets++;
      $check++;
    }
    
    if (($cNon_related==5)||(($cNon_related==4)&&($cUndecidable==0))){
      $Unanimous++;
      $annot{$tweet_id}="non_related";
      $numNonRelatedTweets++;
      $numAnnotatedTweets++;
      $check++;
    }
    
    
    
    if ((($cRelated==3)||($cRelated==4))&&($cUndecidable>0)){
      $QuasiUnanimous++;
      $annot{$tweet_id}="related";
      $numRelatedTweets++;
      $numAnnotatedTweets++;
      $check++;
    }
    
    if ((($cNon_related==3)||($cNon_related==4))&&($cUndecidable>0)){
      $QuasiUnanimous++;
      $annot{$tweet_id}="non_related";
      $numNonRelatedTweets++;
      $numAnnotatedTweets++;
      $check++;
    }

#####################33
#Considerando 3 contra 2
    if (($cNon_related==3)&&($cRelated==2)){
      $QuasiUnanimous++;
      $annot{$tweet_id}="non_related";
      $numNonRelatedTweets++;
      $numAnnotatedTweets++;
      $check++;
    }
    if (($cNon_related==2)&&($cRelated==3)) {
      $QuasiUnanimous++;
      $annot{$tweet_id}="related";
      $numNonRelatedTweets++;
      $numAnnotatedTweets++;
      $check++;
    }
###############33
    
 #   if ((($cNon_related==3)&&($cRelated==2))||
#	(($cNon_related==2)&&($cRelated==3))){
#      $DiscardedBis++;
#      $check++;
#    }

    
    if ((($cRelated==2)||($cNon_related==2))&&($cUndecidable>0)){
      $ToMetaAnnotate++;
      $check++;
      if ($meta_annotation eq "-"){
#	print " $tweet_id\n";
      }
      if ($meta_annotation eq "related"){
	$MetaAnnotated++;
	$annot{$tweet_id}="related";
	$numAnnotatedTweets++; 
	$numRelatedTweets++;
      }
      if ($meta_annotation eq "non_related"){
	$MetaAnnotated++;
	$annot{$tweet_id}="non_related";
	$numAnnotatedTweets++; 
	$numNonRelatedTweets++;
      }
      if ($meta_annotation eq "undecidable"){
	$MetaAnnotated++;
	$annot{$tweet_id}="undecidable";
	$numDiscardedInMetaAnnotation++;
      }
    }
  
    
    if (($cRelated<2)&&($cNon_related<2)){
      $Discarded++;
      $check++;
    }
    if ($check==0){
    #  print "non captured $tweet_id\n";
    }
    if ($check>1){
     # print "extra captured $tweet_id $check \n";
    }
  }
  }
}
  
close (FICH);


print "Tweets with empty annotation \t$numTweetsWithEmptyAnnotation\n";
print "Number  of tweets \t $numTweets\n";
print "Number tweets for evaluation (\t $numAnnotatedTweets\n";
print "Num of related tweets \t $numRelatedTweets\n";
print "Num of non related tweets \t $numNonRelatedTweets\n";

my $numEntities=keys (%entityNames);
print "Number of entities\t$numEntities\n";




my %prePos=();
my %recPos=();
my %preNeg=();
my %recNeg=();
my %FNeg=();
my %FPos=();
my %acc=();
my %numNonProcessedTweets=();
my %prePosUIR=();
my %recPosUIR=();
my %preNegUIR=();
my %recNegUIR=();



 
foreach my $system (@systems){
  my $generalSamples=0;
  open (FICH,"$system") or die; 
  
  print  "RUN\tEntity\tTweets\tPositive Tweets\tNegative Tweets\tAccuracy\tPrecision (positive class)\tRecall (positive class)\tF measure (Positive Class)\tPrecision (negative class)\tRecall (negative class)\tF measure (negative class)\tNon procesed tweets\n";
  
  my %tweetRes=();
  my $numTweets=0;   
  my $numEntities=0;
  $numNonProcessedTweets{$system}=0;
  while (my $line=<FICH>){
    chop $line;
    (my $entity, my $tweet, my $res)=split(/\t/,$line);
    $tweetRes{$tweet}=$res;
    $numTweets++;
  }

  foreach my $entity (keys %entityNames){
    $numEntities++;
    my $samples=0;
    my $TT=0;
    my $FT=0;
    my $TF=0;
    my $FF=0;
    my $ET=0;
    my $EF=0;
    my $nonProcessed=0;
    
    
    foreach my $tweet (keys %annot){
      if ($tweetEntity{$tweet} eq $entity){	
	$samples++;
	if (!(exists $tweetRes{$tweet})){
	  $tweetRes{$tweet}="empty";
	  $numNonProcessedTweets{$system}++; 
	  $nonProcessed++;
	}
	if (($annot{$tweet} eq "related")&&
	    ($tweetRes{$tweet}=~ /TRUE/)){
	  $TT++;
	}
	if (($annot{$tweet} eq "non_related")&&
	    ($tweetRes{$tweet}=~ /TRUE/)){
	  $TF++;
	}
	
	if (($annot{$tweet} eq "related")&&
	    ($tweetRes{$tweet}=~ /FALSE/)){
	  $FT++;
	}
	if (($annot{$tweet} eq "non_related")&&
	    ($tweetRes{$tweet}=~ /FALSE/)){
	  $FF++;
	}

	if (($annot{$tweet} eq "related")&&
	    ($tweetRes{$tweet}=~ /empty/)){
	  $ET++;
	}
	if (($annot{$tweet} eq "non_related")&&
	    ($tweetRes{$tweet}=~ /empty/)){
	  $EF++;
	}
	
      }
    }
    
    my $prePosEnt;
    my $recPosEnt;
    my $FPosEnt;
    my $preNegEnt;
    my $recNegEnt;
    my $FNegEnt;
    my $accEnt;

    if (($TT+$TF)>0){
      $prePosEnt=$TT/($TT+$TF);
    }else{
       $prePosEnt=1;
     }
    if (($TT+$FT+$ET)>0){
      $recPosEnt=$TT/($TT+$FT+$ET);
    }else{
      $recPosEnt=1;
    }

  if (($FF+$FT)>0){
      $preNegEnt=$FF/($FF+$FT);
    }else{
       $preNegEnt=1;
     }
    if (($FF+$TF+$EF)>0){
      $recNegEnt=$FF/($FF+$TF+$EF);
    }else{
      $recNegEnt=1;
    }
    $accEnt=($FF+$TT)/($FF+$FT+$EF+$ET+$TF+$TT);

    $prePosUIR{$system}{$entity}=$prePosEnt;
    $recPosUIR{$system}{$entity}=$recPosEnt;
    $preNegUIR{$system}{$entity}=$preNegEnt;
    $recNegUIR{$system}{$entity}=$recNegEnt;
    


    $prePos{$system}+=$prePosEnt;
    $recPos{$system}+=$recPosEnt;
    $preNeg{$system}+=$preNegEnt;
    $recNeg{$system}+=$recNegEnt;
    $acc{$system}+=$accEnt;
    if (($prePosEnt==0)||($recPosEnt==0)){
      $FPosEnt=0;
    }else{
      $FPosEnt=1/(0.5/$prePosEnt+0.5/$recPosEnt);
    }
    $FPos{$system}+=$FPosEnt;
    if (($preNegEnt==0)||($recNegEnt==0)){
      $FNegEnt=0;
    }else{
      $FNegEnt=1/(0.5/$preNegEnt+0.5/$recNegEnt);
    }
     $FNeg{$system}+=$FNegEnt;

    
    print  "$system\t$entity\t$samples\t".($TT+$ET+$FT)."\t".($TF+$EF+$FF)."\t$accEnt\t$prePosEnt\t$recPosEnt\t$FPosEnt\t$preNegEnt\t$recNegEnt\t$FNegEnt\t$nonProcessed\n";


  }
  $prePos{$system}=$prePos{$system}/$numEntities;
    $recPos{$system}=$recPos{$system}/$numEntities;
    $preNeg{$system}=$preNeg{$system}/$numEntities;
    $recNeg{$system}=$recNeg{$system}/$numEntities;
    $acc{$system}=$acc{$system}/$numEntities; 
   $FPos{$system}= $FPos{$system}/$numEntities; 
   $FNeg{$system}= $FNeg{$system}/$numEntities; 
    print "Number of entities \t$numEntities\n\n";

}

print "SYSTEM RANKING\n";
print "System\tnon procesed tweets\tAccuracy\tPrecision (positive class)\t recall (positive class)\tPrecision (negative class)\tRecall (negative class)\tF measure (positive class)\tF measure (negative class)\n";
foreach my $system (@systems){
   print "$system\t$numNonProcessedTweets{$system}\t$acc{$system}\t$prePos{$system}\t$recPos{$system}\t$preNeg{$system}\t$recNeg{$system}\t$FPos{$system}\t$FNeg{$system}\n";
}

print "\n\nUIR ranking\n";
print "System\tAccuracy\tImproved systems according to UIR>0.1\n";
my  %UIR=();
if (@systems>1){
  
  $numEntities=0;
  foreach my $entity (keys %entityNames){
    $numEntities++;
  }
  
  foreach my $system1 (@systems){
    print "\n$system1\t$acc{$system1}\t";
    foreach my $system2 (@systems){
      $UIR{$system1}{$system2}=0;
      my $imp1=0;
      my $imp2=0;
      foreach my $entity (keys %entityNames){
	
	if (!(($prePosUIR{$system1}{$entity}<$prePosUIR{$system2}{$entity})||
	      ($recPosUIR{$system1}{$entity}<$recPosUIR{$system2}{$entity})||
	      ($preNegUIR{$system1}{$entity}<$preNegUIR{$system2}{$entity})||
	      ($recNegUIR{$system1}{$entity}<$recNegUIR{$system2}{$entity}))){
	  $imp1++;
	}
	if (!(($prePosUIR{$system1}{$entity}>$prePosUIR{$system2}{$entity})||
	      ($recPosUIR{$system1}{$entity}>$recPosUIR{$system2}{$entity})||
	      ($preNegUIR{$system1}{$entity}>$preNegUIR{$system2}{$entity})||
	      ($recNegUIR{$system1}{$entity}>$recNegUIR{$system2}{$entity}))){
	  $imp2++;
	}
      }
      $UIR{$system1}{$system2}=(($imp1-$imp2)/$numEntities);
      #    print "$system1\t$system2\t$imp1\t$imp2\t".(($imp1-$imp2)/$numEntities)."\t".($acc{$system1}-$acc{$system2})."\n";
      if ($UIR{$system1}{$system2}>0.099999){
	print "$system2 ";
      }
    }
  }


  print "\n\nUIR data per system pair\n";
  foreach my $system1 (@systems){
    foreach my $system2 (@systems){
      if (($UIR{$system1}{$system2}>-0.0000001)&&
	  ($system1 ne $system2)){
	print "$system1\t$system2\t$UIR{$system1}{$system2}\n";
      }
    }
  }
}
